<?php

namespace Sma\Transaction;

use User;

class Transaction
{
    /**
     * $transaction object.
     */
    protected $transaction;

    /**
     * Constructor.
     */
    public function __construct(\Sma\Transaction\Interfaces\TransactionRepositoryInterface $transaction)
    {
        $this->transaction = $transaction;
    }

    /**
     * Returns count of transaction.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.transaction.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->transaction->pushCriteria(new \Litepie\Sma\Repositories\Criteria\TransactionUserCriteria());
        }

        $transaction = $this->transaction->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('transaction::' . $view, compact('transaction'))->render();
    }
}
